git-mergetool--lib.sh 7.39 KB
Newer Older
1
#!/bin/sh
2
# git-mergetool--lib is a library for common merge tool functions
3 4

: ${MERGE_TOOLS_DIR=$(git --exec-path)/mergetools}
5

6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22
mode_ok () {
	if diff_mode
	then
		can_diff
	elif merge_mode
	then
		can_merge
	else
		false
	fi
}

is_available () {
	merge_tool_path=$(translate_merge_tool_path "$1") &&
	type "$merge_tool_path" >/dev/null 2>&1
}

23 24 25 26 27 28 29 30 31 32 33 34 35 36
list_config_tools () {
	section=$1
	line_prefix=${2:-}

	git config --get-regexp $section'\..*\.cmd' |
	while read -r key value
	do
		toolname=${key#$section.}
		toolname=${toolname%.cmd}

		printf "%s%s\n" "$line_prefix" "$toolname"
	done
}

37 38 39
show_tool_names () {
	condition=${1:-true} per_line_prefix=${2:-} preamble=${3:-}
	not_found_msg=${4:-}
40
	extra_content=${5:-}
41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58

	shown_any=
	( cd "$MERGE_TOOLS_DIR" && ls ) | {
		while read toolname
		do
			if setup_tool "$toolname" 2>/dev/null &&
				(eval "$condition" "$toolname")
			then
				if test -n "$preamble"
				then
					printf "%s\n" "$preamble"
					preamble=
				fi
				shown_any=yes
				printf "%s%s\n" "$per_line_prefix" "$toolname"
			fi
		done

59 60 61 62 63 64 65 66 67 68 69 70 71
		if test -n "$extra_content"
		then
			if test -n "$preamble"
			then
				# Note: no '\n' here since we don't want a
				# blank line if there is no initial content.
				printf "%s" "$preamble"
				preamble=
			fi
			shown_any=yes
			printf "\n%s\n" "$extra_content"
		fi

72 73 74 75 76 77 78 79 80
		if test -n "$preamble" && test -n "$not_found_msg"
		then
			printf "%s\n" "$not_found_msg"
		fi

		test -n "$shown_any"
	}
}

81 82 83 84 85 86 87 88 89
diff_mode() {
	test "$TOOL_MODE" = diff
}

merge_mode() {
	test "$TOOL_MODE" = merge
}

translate_merge_tool_path () {
90
	echo "$1"
91 92 93
}

check_unchanged () {
94 95
	if test "$MERGED" -nt "$BACKUP"
	then
96 97
		status=0
	else
98 99
		while true
		do
100 101
			echo "$MERGED seems unchanged."
			printf "Was the merge successful? [y/n] "
102
			read answer || return 1
103 104 105 106 107 108 109 110 111
			case "$answer" in
			y*|Y*) status=0; break ;;
			n*|N*) status=1; break ;;
			esac
		done
	fi
}

valid_tool () {
112 113 114
	setup_tool "$1" && return 0
	cmd=$(get_merge_tool_cmd "$1")
	test -n "$cmd"
115 116
}

117 118 119 120 121 122 123 124 125 126 127 128 129 130 131 132 133 134 135 136 137 138 139 140 141 142 143
setup_user_tool () {
	merge_tool_cmd=$(get_merge_tool_cmd "$tool")
	test -n "$merge_tool_cmd" || return 1

	diff_cmd () {
		( eval $merge_tool_cmd )
		status=$?
		return $status
	}

	merge_cmd () {
		trust_exit_code=$(git config --bool \
			"mergetool.$1.trustExitCode" || echo false)
		if test "$trust_exit_code" = "false"
		then
			touch "$BACKUP"
			( eval $merge_tool_cmd )
			status=$?
			check_unchanged
		else
			( eval $merge_tool_cmd )
			status=$?
		fi
		return $status
	}
}

144
setup_tool () {
145 146
	tool="$1"

Ondřej Bílka's avatar
Ondřej Bílka committed
147
	# Fallback definitions, to be overridden by tools.
148 149 150 151 152 153 154 155 156 157 158 159 160 161 162 163 164
	can_merge () {
		return 0
	}

	can_diff () {
		return 0
	}

	diff_cmd () {
		status=1
		return $status
	}

	merge_cmd () {
		status=1
		return $status
	}
165

166 167 168 169 170
	translate_merge_tool_path () {
		echo "$1"
	}

	if ! test -f "$MERGE_TOOLS_DIR/$tool"
171
	then
172 173
		setup_user_tool
		return $?
174 175 176
	fi

	# Load the redefined functions
177
	. "$MERGE_TOOLS_DIR/$tool"
178 179 180
	# Now let the user override the default command for the tool.  If
	# they have not done so then this will return 1 which we ignore.
	setup_user_tool
181 182 183 184

	if merge_mode && ! can_merge
	then
		echo "error: '$tool' can not be used to resolve merges" >&2
185
		return 1
186 187 188
	elif diff_mode && ! can_diff
	then
		echo "error: '$tool' can only be used to resolve merges" >&2
189
		return 1
190 191
	fi
	return 0
192 193 194
}

get_merge_tool_cmd () {
195
	merge_tool="$1"
196 197
	if diff_mode
	then
198 199
		git config "difftool.$merge_tool.cmd" ||
		git config "mergetool.$merge_tool.cmd"
200
	else
201
		git config "mergetool.$merge_tool.cmd"
202
	fi
203 204
}

205
# Entry point for running tools
206
run_merge_tool () {
207 208 209 210 211
	# If GIT_PREFIX is empty then we cannot use it in tools
	# that expect to be able to chdir() to its value.
	GIT_PREFIX=${GIT_PREFIX:-.}
	export GIT_PREFIX

212
	merge_tool_path=$(get_merge_tool_path "$1") || exit
213 214 215
	base_present="$2"
	status=0

216
	# Bring tool-specific functions into scope
217
	setup_tool "$1" || return 1
218 219 220

	if merge_mode
	then
221
		run_merge_cmd "$1"
222
	else
223
		run_diff_cmd "$1"
224
	fi
225 226 227
	return $status
}

228 229
# Run a either a configured or built-in diff tool
run_diff_cmd () {
230
	diff_cmd "$1"
231 232 233 234
}

# Run a either a configured or built-in merge tool
run_merge_cmd () {
235
	merge_cmd "$1"
236 237
}

238
list_merge_tool_candidates () {
239 240
	if merge_mode
	then
241 242 243 244
		tools="tortoisemerge"
	else
		tools="kompare"
	fi
245 246 247 248
	if test -n "$DISPLAY"
	then
		if test -n "$GNOME_DESKTOP_SESSION_ID"
		then
249 250 251 252
			tools="meld opendiff kdiff3 tkdiff xxdiff $tools"
		else
			tools="opendiff kdiff3 tkdiff xxdiff meld $tools"
		fi
253 254
		tools="$tools gvimdiff diffuse diffmerge ecmerge"
		tools="$tools p4merge araxis bc3 codecompare"
255
	fi
256 257
	case "${VISUAL:-$EDITOR}" in
	*vim*)
258
		tools="$tools vimdiff emerge"
259 260
		;;
	*)
261
		tools="$tools emerge vimdiff"
262 263
		;;
	esac
264 265
}

266
show_tool_help () {
267
	tool_opt="'git ${TOOL_MODE}tool --tool-<tool>'"
268

269 270 271 272
	tab='	'
	LF='
'
	any_shown=no
273 274

	cmd_name=${TOOL_MODE}tool
275 276 277 278 279 280 281 282 283 284
	config_tools=$({
		diff_mode && list_config_tools difftool "$tab$tab"
		list_config_tools mergetool "$tab$tab"
	} | sort)
	extra_content=
	if test -n "$config_tools"
	then
		extra_content="${tab}user-defined:${LF}$config_tools"
	fi

285 286
	show_tool_names 'mode_ok && is_available' "$tab$tab" \
		"$tool_opt may be set to one of the following:" \
287 288
		"No suitable tool for 'git $cmd_name --tool=<tool>' found." \
		"$extra_content" &&
289 290 291 292 293 294 295
		any_shown=yes

	show_tool_names 'mode_ok && ! is_available' "$tab$tab" \
		"${LF}The following tools are valid, but not currently available:" &&
		any_shown=yes

	if test "$any_shown" = yes
296 297 298 299 300 301 302 303
	then
		echo
		echo "Some of the tools listed above only work in a windowed"
		echo "environment. If run in a terminal-only session, they will fail."
	fi
	exit 0
}

304 305
guess_merge_tool () {
	list_merge_tool_candidates
306 307 308 309 310 311 312
	cat >&2 <<-EOF

	This message is displayed because '$TOOL_MODE.tool' is not configured.
	See 'git ${TOOL_MODE}tool --tool-help' or 'git help config' for more details.
	'git ${TOOL_MODE}tool' will now attempt to use one of the following tools:
	$tools
	EOF
313 314

	# Loop over each candidate and stop when a valid merge tool is found.
315
	for tool in $tools
316
	do
317
		is_available "$tool" && echo "$tool" && return 0
318 319
	done

320
	echo >&2 "No known ${TOOL_MODE} tool is available."
321
	return 1
322 323 324 325 326
}

get_configured_merge_tool () {
	# Diff mode first tries diff.tool and falls back to merge.tool.
	# Merge mode only checks merge.tool
327 328
	if diff_mode
	then
329 330 331
		merge_tool=$(git config diff.tool || git config merge.tool)
	else
		merge_tool=$(git config merge.tool)
332
	fi
333 334
	if test -n "$merge_tool" && ! valid_tool "$merge_tool"
	then
335 336 337 338
		echo >&2 "git config option $TOOL_MODE.tool set to unknown tool: $merge_tool"
		echo >&2 "Resetting to default..."
		return 1
	fi
339
	echo "$merge_tool"
340 341 342 343
}

get_merge_tool_path () {
	# A merge tool has been set, so verify that it's valid.
344
	merge_tool="$1"
345 346
	if ! valid_tool "$merge_tool"
	then
347 348 349
		echo >&2 "Unknown merge tool $merge_tool"
		exit 1
	fi
350 351
	if diff_mode
	then
352
		merge_tool_path=$(git config difftool."$merge_tool".path ||
353
				  git config mergetool."$merge_tool".path)
354 355
	else
		merge_tool_path=$(git config mergetool."$merge_tool".path)
356
	fi
357 358
	if test -z "$merge_tool_path"
	then
359
		merge_tool_path=$(translate_merge_tool_path "$merge_tool")
360
	fi
361
	if test -z "$(get_merge_tool_cmd "$merge_tool")" &&
362 363
		! type "$merge_tool_path" >/dev/null 2>&1
	then
364
		echo >&2 "The $TOOL_MODE tool $merge_tool is not available as"\
365
			 "'$merge_tool_path'"
366 367 368 369 370 371 372
		exit 1
	fi
	echo "$merge_tool_path"
}

get_merge_tool () {
	# Check if a merge tool has been configured
373
	merge_tool=$(get_configured_merge_tool)
374
	# Try to guess an appropriate merge tool if no tool has been set.
375 376
	if test -z "$merge_tool"
	then
377
		merge_tool=$(guess_merge_tool) || exit
378 379 380
	fi
	echo "$merge_tool"
}